module Embulk
  module Input

    class RedisCustomRestockNoti < InputPlugin
      require 'redis'
      
      Plugin.register_input("redis_custom_restock_noti", self)

      def self.transaction(config, &control)
        task = {
          'host' => config.param('host', :string, :default => 'localhost'),
          'port' => config.param('port', :integer, :default => 6379),
          'db' => config.param('db', :integer, :default => 0),
          'keys_pattern' => config.param('keys_pattern', :string, :default => ''),
          'columns' =>
            config.param('columns', :array, :default => []).inject({}){|a, col|
              a[col['name']] = col['type'].to_sym
              a
            },
          'rows' => 0
        }

        columns = task['columns'].map.with_index{|(name, type), i|
          Column.new(i, name, type)
        }

        puts "Redis input started."
        commit_reports = yield(task, columns, 1)
        puts "Redis input finished. Commit reports = #{commit_reports.to_json}"

        return {}
      end

      # def self.resume(task, columns, count, &control)
      #   task_reports = yield(task, columns, count)

      #   next_config_diff = {}
      #   return next_config_diff
      # end

      # TODO
      # def self.guess(config)
      #   sample_records = [
      #     {"example"=>"a", "column"=>1, "value"=>0.1},
      #     {"example"=>"a", "column"=>2, "value"=>0.2},
      #   ]
      #   columns = Guess::SchemaGuess.from_hash_records(sample_records)
      #   return {"columns" => columns}
      # end

      # def init
      #   # initialization code:
      #   @option1 = task["option1"]
      #   @option2 = task["option2"]
      #   @option3 = task["option3"]
      # end

      def run
        puts "Redis input thread #{@index}..."
        r = Redis.new(:host => @task['host'], :port => @task['port'], :db => @task['db'])
        r.keys("#{@task['keys_pattern']}").each do |key|

          k = key.split(':')
          v = r.zrange(key, 0, -1, :with_scores => true)
        
          v.each do |e|
            temp = Array.new
            temp.push(k[1]) # siteUid
            temp.push(k[3].split('-')[0]) # productCode
            temp.push(k[3].split('-')[1]) # size
            temp.push(e[0]) # customerUid
            temp.push(Time.at(e[1] / 1000)) # score(timestamp)
            @page_builder.add(temp)
          end

          @task['rows'] += 1
        end
        @page_builder.finish  # don't forget to call finish :-)

        commit_report = {
          "rows" => @task['rows']
        }
        return commit_report
      end
    end

  end
end
